package edu.reduc.ds.lineal;

public class LinealUtil {
	
	@SafeVarargs
	public static <T> void add(IList<T> list, T... items) {
		for (T t : items) {
			list.add(t);
		}
	}
	
	public static<T> void checkRange(IList<T> l,int index) {
		if (index >= l.size() || index < 0)
			throw new IndexOutOfBoundsException(outOfBoundsMsg(l,index));

	}
	
	@SuppressWarnings("unchecked")
	public static<T> T[] toTArray(IList<T>l) {
		Object[]x=new Object[l.size()];
		int i=0;
		Iterator<T>it=l.getIterator();
		while(it.hasNext()) {
			x[i++]=it.next();
		}
		return (T[])x;
	}
	
	private static<T> String outOfBoundsMsg(IList<T> l,int index) {
		return "Index: " + index + ", Size: " + l.size();
	}
}
