package edu.reduc.ds.lineal;

import labLinkedList.Establecimientos;

public class LinkedList<E> implements IList<E> {
	Node<E> first, last;
	int size;

	public LinkedList() {
		first = null;
		last = first;
		size = 0;
	}

	@Override
	public void add(E e) {
		Node<E> newNode = new Node<E>(e, null);
		if (isEmpty()) {
			first = newNode;
		} else {
			last.setNext(newNode);
		}
		last = newNode;
		size++;
	}

	@Override
	public void add(E e, int index, boolean override) {
		LinealUtil.checkRange(this, index);
		Node<E> prev = node(index - 1);
		Node<E> n = new Node<E>(e, prev.getNext());
		if (override)
			n.setNext(n.getNext().getNext());
		prev.setNext(n);
	}

	@Override
	public E remove(E e) {
		E element=null;
		int index=indexOf(e);
		boolean f=index!=-1;
		if(f) {
			element=remove(index);
		}
		return element;
	}

	@Override
	public E remove(int index) {
		Node<E> n=node(index);
		E e=n.getItem();
		Node<E>prev=node(index-1);
		prev.setNext(n.getNext());
		return e;
	}

	private Node<E> node(int index) {
		LinealUtil.checkRange(this, index);
		if (index == 0) {
			return first;
		}
		Node<E> x = first;
		for (int i = 0; i < index; i++)
			x = x.getNext();
		return x;
	}

	@Override
	public boolean contains(E e) {
		return indexOf(e) != -1;
	}

	@Override
	public int size() {
		return size;
	}

	@Override
	public E get(int index) {
		return node(index).getItem();
	}

	@Override
	public boolean isEmpty() {
		return size == 0;
	}

	@Override
	public int indexOf(E e) {
		int i;
		boolean f = false;
		Node<E> x = first;
		for (i = 0; i < size && !f; i++) {
			f = x.getItem().equals(e);
			x = x.getNext();
		}
		return !f ? -1 : i - 1;
	}

	@Override
	public Iterator<E> getIterator() {
		return new Iterator<E>(this);
	}

	@Override
	public String toString() {
		StringBuffer list = new StringBuffer("[ ");
		for (Node<E> x = first; x != null; x = x.getNext()) {
			list.append(x.toString() + " ");
		}
		list.append("]");
		return list.toString();
	}
}
